/* Usage: java liarliar_test <n> <avg_accusations> <seed> <output_file>
 * n is the number of veteran members, no less than 20.
 * avg_accusations is the average number of accusations made by each member, no less than 2 and no greater than n.
 * seed is a 64-bit integer used to seed the random number generator.
 *
 * The correct output is written to stdout.
 */
public class liarliar_test {
  public static void main(String[] args) {
    int n = Integer.parseInt(args[0]);
    int avg_accusations = Integer.parseInt(args[1]);
    if (n < 20 || avg_accusations < 2 || avg_accusations > n) {
      System.exit(1);
    }
    long seed = Long.parseLong(args[2]);
    java.util.Random r = new java.util.Random(seed);
    Spacer sp = new Spacer(args[3]);
    boolean[] lying = new boolean[n];
    for (int i = 0; i < 2; i++) {
      lying[i] = i == 1;
    }
    for (int i = 2; i < n; i++) {
      lying[i] = r.nextBoolean();
    }
    double[] rank = new double[n];
    for (int i = 0; i < n; i++) {
      rank[i] = 2 * r.nextGaussian();
    }
    java.util.List<java.util.Set<Integer> > accused = new java.util.ArrayList<java.util.Set<Integer> >(n);
    int num_lying = 0;
    for (int i = 0; i < n; i++) {
      accused.add(new java.util.HashSet<Integer>());
    }
    for (int i = 0; i < n; i++) {
      for (int d = 0; d < avg_accusations; d++) {
        int j;
        do {
          j = r.nextInt(n);
        } while (lying[i] == lying[j]);
        if (rank[i] + r.nextGaussian() > rank[j]) {
          accused.get(i).add(j);
        } else {
          accused.get(j).add(i);
        }
      }
      if (lying[i]) {
        num_lying++;
      }
    }
    sp.print(n);
    sp.println();
    for (int i = 0; i < n; i++) {
      sp.printName(i);
      sp.printSpace();
      sp.print(accused.get(i).size());
      sp.println();
      for (int j : accused.get(i)) {
        sp.printName(j);
        sp.println();
      }
    }
    sp.close((int)seed % 3);
    int a = num_lying;
    int b = n - num_lying;
    System.out.printf("%d %d\n", Math.max(a, b), Math.min(a, b));
  }
}
