/* Usage: java liarliar_test_tree <n> <seed> <output_file>
 * n is the number of veteran members, no less than 1.
 * seed is a 64-bit integer used to seed the random number generator.
 */
import java.util.Random;
import java.util.SortedSet;
import java.util.TreeSet;
class liarliar_test_tree {
  public static void main(String[] args) {
    int n = Integer.parseInt(args[0]);
    if (n < 1) {
      System.exit(1);
    }
    long seed = Long.parseLong(args[1]);
    Random r = new Random(seed);
    Spacer sp = new Spacer(args[2]);
    int[] label = new int[n - 2];
    int[] d = new int[n];
    for(int i = 0; i < n - 2; i++) {
      ++d[(label[i] = r.nextInt(n))];
    }
    SortedSet<Integer> s = new TreeSet<Integer>();
    for(int i = 0; i < n; i++) {
      if(d[i] == 0) {
        s.add(i);
      }
    }
    sp.print(n);
    sp.println();
    for(int i = 0; i < n - 2; i++) {
      int j = s.first();
      s.remove(j);
      sp.printName(j);
      sp.printSpace();
      sp.print(1);
      sp.println();
      sp.printName(label[i]);
      sp.println();
      if(--d[label[i]] == 0) {
        s.add(label[i]);
      }
    }
    sp.printName(s.first());
    sp.printSpace();
    sp.print(1);
    sp.println();
    sp.printName(s.last());
    sp.println();
    sp.printName(s.last());
    sp.printSpace();
    sp.print(0);
    sp.println();
    sp.close((int)seed % 3);
  }
}
